import processing.core.*; 
import processing.xml.*; 

import controlP5.*; 
import ddf.minim.analysis.*; 
import ddf.minim.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Entropy_Machine___v1_4 extends PApplet {

/*
Entropy Machine - v1.3
 
 Features: changable number of chunks, rate of change, 
 emphasis of frequency ranges.
 
 Design Purpose: adding real time gui
 Limitations: mono files only, no recording implementation, .wav only
 */




ControlP5 controlP5;
Minim minim;
AudioSample tune;
FFT fftLog;
ControlWindow controlWindow;

//for controlbox
int myColorBackground = color(0,0,0);

//vairables to make sliders work
int NumberOfChunks = 8;
int RateOfChange = 1;
int LowMult = 1;
int MidLowMult = 1;
int MidMult = 1;
int MidHighMult = 1;
int HighMult = 1;
float Delay = 11.5f;

ArrayList[] accums = new ArrayList[5];

int bufferSize = 1024;

//ARTISTIC VARIABLES
int numChunks = 8;
//higher value equals more changes per iteration
int rateOfChange = 1;
//freq range multipliers l=low etc
int lMult = 0;
int mlMult = 5;
int mMult = 2;
int mhMult = 4;
int hMult = 0;

public void setup()
{
  //setting up controlP5
  controlP5 = new ControlP5(this);
  controlP5.setAutoDraw(false);
  controlWindow = controlP5.addControlWindow("Control Box",100,100,800,400);
  controlWindow.hideCoordinates();

//building the sliders
  controlWindow.setBackground(color(40));
  controlP5.Slider mySlider = controlP5.addSlider("NumberOfChunks",1,200,8,20,100,10,200);
  mySlider.setWindow(controlWindow);
  controlP5.Slider mySlider1 = controlP5.addSlider("RateOfChange",1,100,1,120,100,10,200);
  mySlider1.setWindow(controlWindow);
  controlP5.Slider mySlider2 = controlP5.addSlider("LowMult",1,20,1,240,100,10,200);
  mySlider2.setWindow(controlWindow);
  mySlider2.setNumberOfTickMarks(20);
  controlP5.Slider mySlider3 = controlP5.addSlider("MidLowMult",1,20,1,310,100,10,200);
  mySlider3.setWindow(controlWindow);
  mySlider3.setNumberOfTickMarks(20);
  controlP5.Slider mySlider4 = controlP5.addSlider("MidMult",1,20,1,380,100,10,200);
  mySlider4.setWindow(controlWindow);
  mySlider4.setNumberOfTickMarks(20);
  controlP5.Slider mySlider5 = controlP5.addSlider("MidHighMult",1,20,1,450,100,10,200);
  mySlider5.setWindow(controlWindow);
  mySlider5.setNumberOfTickMarks(20);
  controlP5.Slider mySlider6 = controlP5.addSlider("HighMult",1,20,1,520,100,10,200);
  mySlider6.setWindow(controlWindow);
  mySlider6.setNumberOfTickMarks(20);
  controlP5.Slider mySlider7 = controlP5.addSlider("Delay",0,15,11.5f,600,100,10,200);
  mySlider7.setWindow(controlWindow);
  mySlider7.setNumberOfTickMarks(30);

//setting up minim
  minim = new Minim(this);
  tune = minim.loadSample("sample.wav");

//setting up FFT
  fftLog = new FFT(bufferSize, 44100);
  fftLog.logAverages(704, 1);

//defining the arraylists within my array
  accums[0] = new ArrayList();
  accums[1] = new ArrayList();
  accums[2] = new ArrayList();
  accums[3] = new ArrayList();
  accums[4] = new ArrayList();

}

public void draw()
{

  controlP5.draw();

  tune.trigger();
  println("NumChunks: " + numChunks + " RateOfChange: " + rateOfChange + " Delay: " + Delay);

  int Dlay = PApplet.parseInt(Delay * 1000);
  
  delay(Dlay);

//for slider
  rateOfChange = RateOfChange;

//allow for an increase in the rate of change
  for(int q = 0; q < rateOfChange; q++)
  {
    fft();

    processing();

    movement();
  }


 // println("NumChunks: " + numChunks + " RateOfChange: " + rateOfChange + " Delay: " + Delay);
}

public void stop()
{
  // always close Minim audio classes when you finish with them
  tune.close();
  minim.stop();

  super.stop();
}



public void fft()
{
  //dump the samples into an array
  float[] leftChannel = tune.getChannel(BufferedAudio.LEFT);

  //cut up the samples array into buffer chunks for FFT
  for(int n = 0; n < (leftChannel.length / bufferSize); n++)
  {

    float[] tempBuffer = new float[bufferSize];
    arrayCopy(leftChannel, (n * bufferSize),
    tempBuffer, 0, bufferSize);

    fftLog.forward(tempBuffer);

    //send FFT data to proper accum
    for(int i = 0; i < fftLog.avgSize(); i++)
      accums[i].add(fftLog.getAvg(i));

  }
}

int sampChunkSize = 0;

float[] newSample; 

public void movement()
{
//dump samples for this method
  float[] leftChannel = tune.getChannel(BufferedAudio.LEFT);

//do some math
  int sampChunkNum = numChunks * 2;

//make a dummy array
  float[] newSample = new float[leftChannel.length];

  sampChunkSize = newSample.length / sampChunkNum;

//copy the samples to the dummy array
  arraycopy(leftChannel, 0, newSample, 0, leftChannel.length);

//copy the dummy array back into the samples array, but switch the necessary chunks
  for(int m = 0; m < sampChunkNum; m++)
  {
    if((m == (bigChunkPos * 2)) || (m == (smallChunkPos * 2)))
    {
     // println("ChunkSize: " + sampChunkSize + " srcPos: " + ((smallChunkPos * 2) * sampChunkSize) + " destPos: " + 
     // ((bigChunkPos *2) * sampChunkSize));
      
      
      arraycopy(newSample, ((smallChunkPos * 2) * sampChunkSize), leftChannel, 
      ((bigChunkPos *2) * sampChunkSize), sampChunkSize);
      arraycopy(newSample, ((bigChunkPos * 2) * sampChunkSize), leftChannel, 
      ((smallChunkPos * 2) * sampChunkSize), sampChunkSize);
      
      
    }

  }

}


int arraySize = 0;
int chunkSize = 0;

float lchunkSum = 0;
float mlchunkSum = 0;
float mchunkSum = 0;
float mhchunkSum = 0;
float hchunkSum = 0;

float chunkTotal = 0;

float[] totalsOfChunks;

int bigChunkPos = 0;
int smallChunkPos = 0;

public void processing()
{

  arraySize = accums[0].size();

  //for slider
  numChunks = NumberOfChunks;

  totalsOfChunks = new float[numChunks];

  chunkSize = arraySize / numChunks;

  //tally up the accums over a chunk size
  for(int j = 0; j < numChunks; j++)
  {

    lchunkSum = 0;
    mlchunkSum = 0;
    mchunkSum = 0;
    mhchunkSum = 0;
    hchunkSum = 0;
    chunkTotal = 0;

    for(int i = (0 + (chunkSize * j)); i < (chunkSize * (j + 1)); i++)
    {
      lchunkSum = lchunkSum +  (Float)accums[0].get(i);

      mlchunkSum = mlchunkSum +  (Float)accums[1].get(i);

      mchunkSum = mchunkSum +  (Float)accums[2].get(i);

      mhchunkSum = mhchunkSum +  (Float)accums[3].get(i);

      hchunkSum = hchunkSum +  (Float)accums[4].get(i);
    }

    //send slider data to variables
    lMult = LowMult;
    mlMult = MidLowMult;
    mMult = MidMult;
    mhMult = MidHighMult;
    hMult = HighMult;

    //compute chunk Sums
    lchunkSum = lchunkSum * lMult;
    mlchunkSum = mlchunkSum * mlMult;
    mchunkSum = mchunkSum * mMult;
    mhchunkSum = mhchunkSum * mhMult;
    hchunkSum = hchunkSum * hMult;

//total chunk sums (for one chunk)
    chunkTotal = lchunkSum + mlchunkSum + mchunkSum + mhchunkSum + hchunkSum;

//send chunksum to array of chunksums
    totalsOfChunks[j] = chunkTotal;

  }

  float biggestChunk = 0;
  float smallestChunk = 999999999999999999999999999.99f;

//figure out the biggest and smallest chunksum in one repitition
  for(int k = 0; k < numChunks; k++)
  {
    if(totalsOfChunks[k] > biggestChunk)
    {
      biggestChunk = totalsOfChunks[k];
      bigChunkPos = k;
    }


    if(totalsOfChunks[k] < smallestChunk)
    {
      smallestChunk = totalsOfChunks[k];
      smallChunkPos = k;
    }
  }

}










  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "Entropy_Machine___v1_4" });
  }
}
