/*
Entropy Machine - v1.3
 
 Features: changable number of chunks, rate of change, 
 emphasis of frequency ranges.
 
 Design Purpose: adding real time gui
 Limitations: mono files only, no recording implementation, .wav only
 */
import controlP5.*;
import ddf.minim.analysis.*;
import ddf.minim.*;

ControlP5 controlP5;
Minim minim;
AudioSample tune;
FFT fftLog;
ControlWindow controlWindow;

//for controlbox
int myColorBackground = color(0,0,0);

//vairables to make sliders work
int NumberOfChunks = 8;
int RateOfChange = 1;
int LowMult = 1;
int MidLowMult = 1;
int MidMult = 1;
int MidHighMult = 1;
int HighMult = 1;
float Delay = 11.5;

ArrayList[] accums = new ArrayList[5];

int bufferSize = 1024;

//ARTISTIC VARIABLES
int numChunks = 8;
//higher value equals more changes per iteration
int rateOfChange = 1;
//freq range multipliers l=low etc
int lMult = 0;
int mlMult = 5;
int mMult = 2;
int mhMult = 4;
int hMult = 0;

void setup()
{
  //setting up controlP5
  controlP5 = new ControlP5(this);
  controlP5.setAutoDraw(false);
  controlWindow = controlP5.addControlWindow("Control Box",100,100,800,400);
  controlWindow.hideCoordinates();

//building the sliders
  controlWindow.setBackground(color(40));
  controlP5.Slider mySlider = controlP5.addSlider("NumberOfChunks",1,200,8,20,100,10,200);
  mySlider.setWindow(controlWindow);
  controlP5.Slider mySlider1 = controlP5.addSlider("RateOfChange",1,100,1,120,100,10,200);
  mySlider1.setWindow(controlWindow);
  controlP5.Slider mySlider2 = controlP5.addSlider("LowMult",1,20,1,240,100,10,200);
  mySlider2.setWindow(controlWindow);
  mySlider2.setNumberOfTickMarks(20);
  controlP5.Slider mySlider3 = controlP5.addSlider("MidLowMult",1,20,1,310,100,10,200);
  mySlider3.setWindow(controlWindow);
  mySlider3.setNumberOfTickMarks(20);
  controlP5.Slider mySlider4 = controlP5.addSlider("MidMult",1,20,1,380,100,10,200);
  mySlider4.setWindow(controlWindow);
  mySlider4.setNumberOfTickMarks(20);
  controlP5.Slider mySlider5 = controlP5.addSlider("MidHighMult",1,20,1,450,100,10,200);
  mySlider5.setWindow(controlWindow);
  mySlider5.setNumberOfTickMarks(20);
  controlP5.Slider mySlider6 = controlP5.addSlider("HighMult",1,20,1,520,100,10,200);
  mySlider6.setWindow(controlWindow);
  mySlider6.setNumberOfTickMarks(20);
  controlP5.Slider mySlider7 = controlP5.addSlider("Delay",0,15,11.5,600,100,10,200);
  mySlider7.setWindow(controlWindow);
  mySlider7.setNumberOfTickMarks(30);

//setting up minim
  minim = new Minim(this);
  tune = minim.loadSample("sample.wav");

//setting up FFT
  fftLog = new FFT(bufferSize, 44100);
  fftLog.logAverages(704, 1);

//defining the arraylists within my array
  accums[0] = new ArrayList();
  accums[1] = new ArrayList();
  accums[2] = new ArrayList();
  accums[3] = new ArrayList();
  accums[4] = new ArrayList();

}

void draw()
{

  controlP5.draw();

  tune.trigger();
  println("NumChunks: " + numChunks + " RateOfChange: " + rateOfChange + " Delay: " + Delay);

  int Dlay = int(Delay * 1000);
  
  delay(Dlay);

//for slider
  rateOfChange = RateOfChange;

//allow for an increase in the rate of change
  for(int q = 0; q < rateOfChange; q++)
  {
    fft();

    processing();

    movement();
  }


 // println("NumChunks: " + numChunks + " RateOfChange: " + rateOfChange + " Delay: " + Delay);
}

void stop()
{
  // always close Minim audio classes when you finish with them
  tune.close();
  minim.stop();

  super.stop();
}



